Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.exist.xquery
Class Function

    java.lang.Object
      org.exist.xquery.AbstractExpression
          org.exist.xquery.PathExpr
              org.exist.xquery.Function

All Implemented Interfaces:
  CompiledExpression, CompiledXQuery, Expression

Direct Known Subclasses:
  BasicFunction, CallFunction, CatchFunction, CollatingFunction, DescribeFunction, ExtCollection, ExtDoctype, ExtDocument, ExtFulltext, ExtRegexp, FtIndexLookup, FunAbs, FunAvg, FunBoolean, FunCeiling, FunConcat, FunCount, FunctionCall, FunCurrentDateTime, FunData, FunDeepEqual, FunDistinctValues, FunDoc, FunDocAvailable, FunDocumentURI, FunEmpty, FunEncodeForURI, FunEscapeHTMLURI, FunExactlyOne, FunExists, FunFloor, FunId, FunImplicitTimezone, FunInsertBefore, FunIRIToURI, FunItemAt, FunLang, FunLast, FunLocalName, FunMatches, FunName, FunNamespaceURI, FunNodeName, FunNormalizeSpace, FunNot, FunNumber, FunOneOrMore, FunPosition, FunRemove, FunReverse, FunRoot, FunRound, FunRoundHalfToEven, FunString, FunStringPad, FunStrLength, FunSubSequence, FunSubstring, FunSum, FunTranslate, FunUnordered, FunUpperOrLowerCase, FunZeroOrOne, GetAttribute, GetID, InternalFunctionCall, JavaCall, LockFunction, MatchRegexp, MD5, QNameIndexLookup, RangeExpression, RemoveAttribute, SetAttribute, SetCookie, SetHeader, UserDefinedFunction

public abstract class Function
extends PathExpr

Abstract base class for all built-in and user-defined functions. Built-in functions just extend this class. A new function instance will be created for each function call. Subclasses have to provide a function signature to the constructor. User-defined functions extend class `UserDefinedFunction`, which is again a subclass of Function. They will not be called directly, but through a `FunctionCall` object, which checks the type and cardinality of all arguments and takes care that the current execution context is saved properly.

Author:
  wolf

Field Summary
`static java.lang.String` | `BUILTIN_FUNCTION_NS`

Fields inherited from interface org.exist.xquery.Expression
`DOT_TEST, EXPRESSION_ID_INVALID, IGNORE_CONTEXT, IN_PREDICATE, IN_UPDATE, IN_WHERE_CLAUSE, NO_CONTEXT_ID, SINGLE_STEP_EXECUTION`

Method Summary
`void` | `analyze(AnalyzeContextInfo contextInfo)` Statically analyze the expression and its subexpressions.
`static Function` | `createFunction(XQueryContext context, XQueryAST ast, FunctionDef def)` Create a built-in function from the specified class.
`void` | `dump(ExpressionDumper dumper)` Write a diagnostic dump of the expression to the passed `ExpressionDumper`.
`abstract Sequence` | `eval(Sequence contextSequence, Item contextItem)` Evaluate the expression represented by this object.
`Expression` | `getArgument(int pos)` Get an argument expression by its position in the argument list.
`int` | `getArgumentCount()` Get the number of arguments passed to this function.
`Sequence[]` | `getArguments(Sequence contextSequence, Item contextItem)`
`XQueryAST` | `getASTNode()` Returns the `XQueryAST` node from which this expression has been constructed by the parser.
`int` | `getCardinality()` The default cardinality is `Cardinality.EXACTLY_ONE`.
`int` | `getDependencies()` Returns `Dependency.DEFAULT_DEPENDENCIES`.
`QName` | `getName()` Return the name of this function.
`Expression` | `getParent()` Returns the expression from which this function gets called.
`FunctionSignature` | `getSignature()` Get the signature of this function.
`boolean` | `isCalledAs(java.lang.String localName)`
`int` | `returnsType()` The static return type of the expression.
`void` | `setArguments(java.util.List arguments)` Set the (static) arguments for this function from a list of expressions.
`void` | `setASTNode(XQueryAST ast)`
`void` | `setParent(Expression parent)` Set the parent expression of this function, i.e.
`void` | `setPrimaryAxis(int axis)`
`java.lang.String` | `toString()`

Methods inherited from class org.exist.xquery.PathExpr
`accept, add, add, addPath, addPredicate, dump, getContext, getDocumentSet, getExpression, getLastExpression, getLength, getLiteralValue, getSource, isValid, replaceLastExpression, reset, resetState, setContext, setSource`

Methods inherited from class org.exist.xquery.AbstractExpression
`eval, getContextDocSet, getContextId, getExpressionId, setContextDocSet`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface org.exist.xquery.CompiledXQuery
`eval`

Field Detail

### BUILTIN_FUNCTION_NS

    public static final java.lang.String BUILTIN_FUNCTION_NS

See Also:
  Constant Field Values

Method Detail

### returnsType

    public int returnsType()

  Description copied from interface: `Expression`
  The static return type of the expression. This method should return one of the type constants defined in class `Type`. If the return type cannot be determined statically, return Type.ITEM.

  Specified by:
    `returnsType` in interface `Expression`
  Overrides:
    `returnsType` in class `PathExpr`

### getCardinality

    public int getCardinality()

  Description copied from class: `AbstractExpression`
  The default cardinality is `Cardinality.EXACTLY_ONE`.

  Specified by:
    `getCardinality` in interface `Expression`
  Overrides:
    `getCardinality` in class `PathExpr`

### createFunction

    public static Function createFunction(XQueryContext context,
                                          XQueryAST ast,
                                          FunctionDef def)
                                   throws XPathException

  Create a built-in function from the specified class.

  Returns:
    the created function or null if the class could not be initialized.
  Throws:
    `XPathException`

### setParent

    public void setParent(Expression parent)

  Set the parent expression of this function, i.e. the expression from which the function is called.

  Parameters:
    `parent` -

### getParent

    public Expression getParent()

  Returns the expression from which this function gets called.

### setArguments

    public void setArguments(java.util.List arguments)
                      throws XPathException

  Set the (static) arguments for this function from a list of expressions. This will also check the type and cardinality of the passed argument expressions.

  Parameters:
    `arguments` -
  Throws:
    `XPathException`

### analyze

    public void analyze(AnalyzeContextInfo contextInfo)
                 throws XPathException

  Description copied from interface: `Expression`
  Statically analyze the expression and its subexpressions. During the static analysis phase, the query engine can detect unknown variables and some type errors.

  Specified by:
    `analyze` in interface `Expression`
  Overrides:
    `analyze` in class `PathExpr`
  Throws:
    `XPathException`

### eval

    public abstract Sequence eval(Sequence contextSequence,
                                  Item contextItem)
                           throws XPathException

  Description copied from interface: `Expression`
  Evaluate the expression represented by this object. Depending on the context in which this expression is executed, either the context sequence, the context item or both of them may be set. An implementing class should know how to handle this. The general contract is as follows: if the `Dependency.CONTEXT_ITEM` bit is set in the bit field returned by `Expression.getDependencies()`, the eval method will be called once for every item in the context sequence. The contextItem parameter will be set to the current item. Otherwise, the eval method will only be called once for the whole context sequence and contextItem will be null. eXist tries to process the entire context set in one, single step whenever possible. Thus, most classes only expect context to contain a list of nodes which represents the current context of the expression. The position() function in XPath is an example for an expression, which requires both, context sequence and context item to be set. The context sequence might be a node set, a sequence of atomic values or a single node or atomic value.

  Specified by:
    `eval` in interface `Expression`
  Overrides:
    `eval` in class `PathExpr`
  Throws:
    `XPathException`

### getArguments

    public Sequence[] getArguments(Sequence contextSequence,
                                   Item contextItem)
                            throws XPathException

  Throws:
    `XPathException`

### getArgument

    public Expression getArgument(int pos)

  Get an argument expression by its position in the argument list.

  Parameters:
    `pos` -

### getArgumentCount

    public int getArgumentCount()

  Get the number of arguments passed to this function.

  Returns:
    number of arguments

### setPrimaryAxis

    public void setPrimaryAxis(int axis)

  Specified by:
    `setPrimaryAxis` in interface `Expression`
  Overrides:
    `setPrimaryAxis` in class `PathExpr`

### getName

    public QName getName()

  Return the name of this function.

  Returns:
    name of this function

### getSignature

    public FunctionSignature getSignature()

  Get the signature of this function.

  Returns:
    signature of this function

### isCalledAs

    public boolean isCalledAs(java.lang.String localName)

### getDependencies

    public int getDependencies()

  Description copied from class: `AbstractExpression`
  Returns `Dependency.DEFAULT_DEPENDENCIES`.

  Specified by:
    `getDependencies` in interface `Expression`
  Overrides:
    `getDependencies` in class `PathExpr`

### dump

    public void dump(ExpressionDumper dumper)

  Description copied from interface: `Expression`
  Write a diagnostic dump of the expression to the passed `ExpressionDumper`.

  Specified by:
    `dump` in interface `Expression`
  Overrides:
    `dump` in class `PathExpr`

### toString

    public java.lang.String toString()

  Overrides:
    `toString` in class `PathExpr`

### setASTNode

    public void setASTNode(XQueryAST ast)

  Specified by:
    `setASTNode` in interface `Expression`
  Overrides:
    `setASTNode` in class `AbstractExpression`

### getASTNode

    public XQueryAST getASTNode()

  Description copied from interface: `Expression`
  Returns the `XQueryAST` node from which this expression has been constructed by the parser. This node contains location information (line number and column) important for error reports.

  Specified by:
    `getASTNode` in interface `Expression`
  Overrides:
    `getASTNode` in class `PathExpr`

Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (C) Wolfgang Meier. All rights reserved.